#include "ds18b20.h"
//-----------------------------------------------------
struct TEMP_TYPE DS18B20_ReadTemp(uChar *serial_number)
{
	if(ONEWIRE_Init())
	{
		ONEWIRE_WriteByte(MATCH_ROM);
		
		for(uChar count = 0; count < 8; count++)
		{
			ONEWIRE_WriteByte(serial_number[count]);
		}
		
		ONEWIRE_WriteByte(CONVERT_TEMP);
		_delay_ms(750);
		
		if(!ONEWIRE_Init())
		{
			struct TEMP_TYPE temp = {0, 0, 0};
			return temp;
		}			
		
		ONEWIRE_WriteByte(MATCH_ROM);
		
		for(uChar count = 0; count < 8; count++)
		{
			ONEWIRE_WriteByte(serial_number[count]);
		}
		
		ONEWIRE_WriteByte(READ_SCRATCHPAD);
		uChar low = ONEWIRE_ReadByte();
		uChar high = ONEWIRE_ReadByte();
		
		return ONEWIRE_DecodeToDecimal(low, high);
	}
	
	struct TEMP_TYPE temp = {0, 0, 0};
	return temp;
}
//------------------------------------------------------------
void DS18B20_DecodeToString(uChar *str, struct TEMP_TYPE temp)
{
	if(temp.sign)
		strcpy((char*)str, "-");
	else
		strcpy((char*)str, "+");
		
	uChar buffer[25];
	
	sprintf((char*)buffer, "%d.", temp.temp_int);
	strcat((char*)str, (char*)buffer);
	sprintf((char*)buffer, "%d", temp.temp_fract);
	strcat((char*)str, (char*)buffer);
}
//------------------------------------------------
bool DS18B20_GetSerialNumber(uChar *serial_number)
{
	if(ONEWIRE_Init())
	{
		ONEWIRE_WriteByte(READ_ROM);
		
		for(uChar count = 0; count < 8; count++)
		{
			serial_number[count] = ONEWIRE_ReadByte();
		}
		
		return true;
	}
	
	return false;
}