#ifndef	I2C_H
	#define I2C_H
	//--------------------
	#include "../header.h"
	//--------------------
	#define I2C_PORT PORTC
	#define I2C_DDR  DDRC
	#define I2C_PIN  PINC
	//---------------
	#define I2C_SDA 0
	#define I2C_SCL 1
	//----------------
	#define I2C_NASK 0
	#define I2C_ASK  1
	//-----------------
	#define I2C_DELAY 1
	//----------------------------
	#define ADDR_DS1307_WRITE 0xD0
	#define ADDR_DS1307_READ  0xD1
	//-----------------------------
	#define ADDR_DS1307_SECOND 0x00
	#define ADDR_DS1307_MINUTE 0x01
	#define ADDR_DS1307_HOUR   0x02
	//-------------------------------
	#define ADDR_DS1307_WEEK_DAY 0x03
	#define ADDR_DS1307_DAY      0x04
	#define ADDR_DS1307_MONTH    0x05
	#define ADDR_DS1307_YEAR     0x06
	//-------------------------------------
	#define BIT(bit) I2C_PORT |= (1 << bit)
	#define UNBIT(bit) I2C_PORT &= ~(1 << bit)
	//---------------------
	extern void I2C_Init();
	extern void I2C_SDA_SET();
	extern void I2C_SDA_UNSET();
	extern void I2C_SLC_SET();
	extern void I2C_SLC_UNSET();
	extern void I2C_Start();
	extern void I2C_Stop();
	extern uChar I2C_Write(uChar byte);
	extern uChar I2C_Read(uChar ask);
	extern uChar I2C_DecodeToDecimal(uChar byte);
	extern void  I2C_Time(uChar *time);
	extern void  I2C_Date(uChar *date);
	extern uChar I2C_Hour();
	extern uChar I2C_Minute();
	extern uChar I2C_Second();
	extern uChar I2C_Day();
	extern uChar I2C_Month();
	extern uChar I2C_Year();
	extern uChar I2C_DayWeek();
	extern void  I2C_DS1307_Init();
	extern void  I2C_SetTime(uChar hour, uChar minute, uChar second);
	extern void  I2C_SetDate(uChar day, uChar month, uChar year, uChar week_day);
	extern uChar I2C_DecodeToBinDec(uChar byte);
#endif